diff -Naur WindowMaker-0.92.0-orig/src/dock.c WindowMaker-0.92.0/src/dock.c
--- WindowMaker-0.92.0-orig/src/dock.c	2007-01-10 23:36:31.000000000 +0100
+++ WindowMaker-0.92.0/src/dock.c	2007-01-10 23:45:03.000000000 +0100
@@ -105,6 +105,8 @@
 
 static WMPropList *dAutoCollapse, *dAutoRaiseLower, *dOmnipresent;
 
+static WMPropList *dDrawers = NULL;
+
 static void dockIconPaint(WAppIcon *btn);
 
 static void iconMouseDown(WObjDescriptor *desc, XEvent *event);
@@ -125,8 +127,6 @@
 
 static void handleClipChangeWorkspace(WScreen *scr, XEvent *event);
 
-Bool moveIconBetweenDocks(WDock *src, WDock *dest, WAppIcon *icon, int x, int y);
-
 static void clipEnterNotify(WObjDescriptor *desc, XEvent *event);
 static void clipLeaveNotify(WObjDescriptor *desc, XEvent *event);
 static void clipAutoCollapse(void *cdata);
@@ -138,6 +138,16 @@
 
 static void showClipBalloon(WDock *dock, int workspace);
 
+static void drawerIconExpose(WObjDescriptor *desc, XEvent *event);
+static void removeDrawerCallback(WMenu *menu, WMenuEntry *entry);
+static void drawerAppendToChain(WScreen *scr, WDock *drawer);
+static char *findUniqueName(WScreen *scr, char *instance_basename);
+static void addADrawerCallback(WMenu *menu, WMenuEntry *entry);
+static void swapDrawers(WScreen *scr, int on_right_side, int new_x);
+static int isADrawer(WScreen *scr, WAppIcon *aicon);
+static WDock* getDrawer(WScreen *scr, int y_index);
+static int indexOfHole(WDock *drawer, WAppIcon *moving_aicon, int redocking);
+
 
 
 static void
@@ -172,6 +182,7 @@
 
     dDock = WMCreatePLString("Dock");
     dClip = WMCreatePLString("Clip");
+    dDrawers = WMCreatePLString("Drawers");
 }
 
 
@@ -526,14 +537,37 @@
 
 
 static void
+removeIcons(WMArray *icons, WDock *dock)
+{
+    WAppIcon *aicon;
+    int keepit;
+    WMArrayIterator it;
+
+    WM_ITERATE_ARRAY(icons, aicon, it) {
+        keepit = aicon->running && wApplicationOf(aicon->main_window);
+        wDockDetach(dock, aicon);
+        if (keepit) {
+            /* XXX: can: aicon->icon == NULL ? */
+            PlaceIcon(dock->screen_ptr, &aicon->x_pos, &aicon->y_pos, wGetHeadForWindow(aicon->icon->owner));
+            XMoveWindow(dpy, aicon->icon->core->window,
+                        aicon->x_pos, aicon->y_pos);
+            if (!dock->mapped || dock->collapsed)
+                XMapWindow(dpy, aicon->icon->core->window);
+        }
+    }
+    WMFreeArray(icons);
+
+    if (wPreferences.auto_arrange_icons)
+        wArrangeIcons(dock->screen_ptr, True);
+}
+
+
+static void
 removeIconsCallback(WMenu *menu, WMenuEntry *entry)
 {
     WAppIcon *clickedIcon = (WAppIcon*)entry->clientdata;
     WDock *dock;
-    WAppIcon *aicon;
     WMArray *selectedIcons;
-    int keepit;
-    WMArrayIterator it;
 
     assert(clickedIcon!=NULL);
 
@@ -542,7 +576,8 @@
     selectedIcons = getSelected(dock);
 
     if (WMGetArrayItemCount(selectedIcons)) {
-        if (wMessageDialog(dock->screen_ptr, _("Workspace Clip"),
+        if (wMessageDialog(dock->screen_ptr,
+                           dock->type == WM_CLIP ? _("Workspace Clip") : _("Drawer"),
                            _("All selected icons will be removed!"),
                            _("OK"), _("Cancel"), NULL)!=WAPRDefault) {
             WMFreeArray(selectedIcons);
@@ -556,22 +591,7 @@
         WMAddToArray(selectedIcons, clickedIcon);
     }
 
-    WM_ITERATE_ARRAY(selectedIcons, aicon, it) {
-        keepit = aicon->running && wApplicationOf(aicon->main_window);
-        wDockDetach(dock, aicon);
-        if (keepit) {
-            /* XXX: can: aicon->icon == NULL ? */
-            PlaceIcon(dock->screen_ptr, &aicon->x_pos, &aicon->y_pos, wGetHeadForWindow(aicon->icon->owner));
-            XMoveWindow(dpy, aicon->icon->core->window,
-                        aicon->x_pos, aicon->y_pos);
-            if (!dock->mapped || dock->collapsed)
-                XMapWindow(dpy, aicon->icon->core->window);
-        }
-    }
-    WMFreeArray(selectedIcons);
-
-    if (wPreferences.auto_arrange_icons)
-        wArrangeIcons(dock->screen_ptr, True);
+    removeIcons(selectedIcons, dock);
 }
 
 
@@ -639,9 +659,34 @@
 toggleAutoAttractCallback(WMenu *menu, WMenuEntry *entry)
 {
     WDock *dock = (WDock*)entry->clientdata;
+    WScreen *scr = dock->screen_ptr;
 
     assert(entry->clientdata!=NULL);
 
+    /* Ask confirmation if the action has some side-effects */
+    if (dock->type == WM_CLIP && scr->attracting_drawer) {
+        if (wMessageDialog(scr, _("Workspace Clip"),
+                           _("The drawer that auto-attracted icons so far won't do so anymore!"),
+                           _("OK"), _("Cancel"), NULL)!=WAPRDefault)
+            return;
+    } else if (dock->type == WM_DRAWER) {
+        /* check if at least one clip already auto attracts icons */
+        int i, ask_for_confirmation = False;
+        for (i = 0; i < scr->workspace_count; i++) {
+            if (scr->workspaces[ i ]->clip->attract_icons) {
+                ask_for_confirmation = True;
+                break;
+            }
+        }
+        if (ask_for_confirmation) {
+            if (wMessageDialog(scr, _("Drawer"),
+                               _("Any clips that auto-attracted icons so far won't do so anymore!"),
+                               _("OK"), _("Cancel"), NULL)!=WAPRDefault)
+                return;
+        }
+    }
+
+    /* direct effect */
     dock->attract_icons = !dock->attract_icons;
     /*if (!dock->attract_icons)
      dock->keep_attracted = 0;*/
@@ -649,6 +694,26 @@
     entry->flags.indicator_on = dock->attract_icons;
 
     wMenuPaint(menu);
+
+    /* side-effects */
+    if (dock->attract_icons) {
+        if (dock->type == WM_DRAWER) {
+            int i;
+            for (i = 0; i < scr->workspace_count; i++) {
+                scr->workspaces[ i ]->clip->attract_icons = False;
+                /* dock menu will be updated later, when opened */
+            }
+            if (scr->attracting_drawer != NULL)
+                scr->attracting_drawer->attract_icons = False;
+            scr->attracting_drawer = dock;
+        } else {
+            if (scr->attracting_drawer != NULL) {
+                scr->attracting_drawer->attract_icons = False;
+                /* again, its menu will be updated, later. */
+                scr->attracting_drawer = NULL;
+            }
+        }
+    }
 }
 
 
@@ -669,7 +734,7 @@
 colectIconsCallback(WMenu *menu, WMenuEntry *entry)
 {
     WAppIcon *clickedIcon = (WAppIcon*)entry->clientdata;
-    WDock *clip;
+    WDock *clip; /* clip... is a WM_CLIP or a WM_DRAWER */
     WAppIcon *aicon;
     int x, y, x_pos, y_pos;
 
@@ -838,13 +903,17 @@
 }
 
 
+/* Name is only used when type == WM_DRAWER and when restoring a specific
+ * drawer, with a specific name. When creating a drawer, leave name to NULL
+ * and mainIconCreate will find the first unused unique name */
 WAppIcon*
-mainIconCreate(WScreen *scr, int type)
+mainIconCreate(WScreen *scr, int type, char *name)
 {
     WAppIcon *btn;
     int x_pos;
 
-    if (type == WM_CLIP) {
+    switch(type) {
+    case WM_CLIP:
         if (scr->clip_icon)
             return scr->clip_icon;
         btn = wAppIconCreateForDock(scr, NULL, "Logo", "WMClip", TILE_CLIP);
@@ -853,9 +922,20 @@
         btn->icon->core->descriptor.handle_leavenotify = clipLeaveNotify;
         /*x_pos = scr->scr_width - ICON_SIZE*2 - DOCK_EXTRA_SPACE;*/
         x_pos = 0;
-    } else {
+        break;
+    case WM_DOCK:
+    default: /* to avoid a warning about btn and x_pos, basically */
         btn = wAppIconCreateForDock(scr, NULL, "Logo", "WMDock", TILE_NORMAL);
         x_pos = scr->scr_width - ICON_SIZE - DOCK_EXTRA_SPACE;
+        break;
+    case WM_DRAWER:
+        if (name == NULL)
+            name = findUniqueName(scr, "Drawer");
+        btn = wAppIconCreateForDock(scr, NULL, name, "WMDrawer", TILE_DRAWER);
+        btn->icon->core->descriptor.handle_expose = drawerIconExpose;
+        btn->icon->core->descriptor.handle_enternotify = clipEnterNotify;
+        btn->icon->core->descriptor.handle_leavenotify = clipLeaveNotify;
+        x_pos = 0;
     }
 
     btn->xindex = 0;
@@ -897,13 +977,13 @@
 
         WM_ITERATE_ARRAY(selectedIcons, btn, iter) {
             if (wDockFindFreeSlot(dest, &x, &y)) {
-                moveIconBetweenDocks(src, dest, btn, x, y);
+                wDockMoveIconBetweenDocks(src, dest, btn, x, y);
                 XUnmapWindow(dpy, btn->icon->core->window);
             }
         }
     } else if (icon != scr->clip_icon) {
         if (wDockFindFreeSlot(dest, &x, &y)) {
-            moveIconBetweenDocks(src, dest, icon, x, y);
+            wDockMoveIconBetweenDocks(src, dest, icon, x, y);
             XUnmapWindow(dpy, icon->icon->core->window);
         }
     }
@@ -1116,23 +1196,37 @@
     if (type == WM_CLIP && scr->clip_menu)
         return scr->clip_menu;
 
+    if (type == WM_DRAWER && scr->drawer_menu)
+        return scr->drawer_menu;
+
     menu = wMenuCreate(scr, NULL, False);
-    if (type != WM_CLIP) {
+    if (type == WM_DOCK) {
         entry = wMenuAddCallback(menu, _("Keep on Top"),
                                  toggleLoweredCallback, NULL);
         entry->flags.indicator = 1;
         entry->flags.indicator_on = 1;
         entry->flags.indicator_type = MI_CHECK;
-    } else {
-        entry = wMenuAddCallback(menu, _("Clip Options"), NULL, NULL);
-        scr->clip_options = makeClipOptionsMenu(scr);
-        if (scr->clip_options)
-            wMenuEntrySetCascade(menu, entry, scr->clip_options);
 
-        entry = wMenuAddCallback(menu, _("Rename Workspace"), renameCallback,
-                                 NULL);
-        wfree(entry->text);
-        entry->text = _("Rename Workspace");
+        entry = wMenuAddCallback(menu, _("Add a drawer"),
+                                 addADrawerCallback, NULL);
+    } else {
+        if (type == WM_CLIP)
+            entry = wMenuAddCallback(menu, _("Clip Options"), NULL, NULL);
+        else /* if (type == WM_DRAWER) */
+            entry = wMenuAddCallback(menu, _("Drawer options"), NULL, NULL);
+
+        if (scr->clip_options == NULL)
+            scr->clip_options = makeClipOptionsMenu(scr);
+        wMenuEntrySetCascade(menu, entry, scr->clip_options);
+
+        if (type == WM_CLIP) {
+            entry = wMenuAddCallback(menu, _("Rename Workspace"), renameCallback,
+                                     NULL);
+            /* If the text entry may change, free the duplicated string (from
+             * wMenuInsertCallback) and use gettext's string */
+            wfree(entry->text);
+            entry->text = _("Rename Workspace"); /* can be: (Toggle) Omnipresent */
+        }
 
         entry = wMenuAddCallback(menu, _("Selected"), selectCallback, NULL);
         entry->flags.indicator = 1;
@@ -1142,23 +1236,25 @@
         entry = wMenuAddCallback(menu, _("Select All Icons"),
                                  selectIconsCallback, NULL);
         wfree(entry->text);
-        entry->text = _("Select All Icons");
+        entry->text = _("Select All Icons"); /* can be: Unselect all icons */
 
         entry = wMenuAddCallback(menu, _("Keep Icon"), keepIconsCallback, NULL);
         wfree(entry->text);
-        entry->text = _("Keep Icon");
+        entry->text = _("Keep Icon"); /* can be: Keep Icons */
 
-        entry = wMenuAddCallback(menu, _("Move Icon To"), NULL, NULL);
-        wfree(entry->text);
-        entry->text = _("Move Icon To");
-        scr->clip_submenu = makeWorkspaceMenu(scr);
-        if (scr->clip_submenu)
-            wMenuEntrySetCascade(menu, entry, scr->clip_submenu);
+        if (type == WM_CLIP) {
+            entry = wMenuAddCallback(menu, _("Move Icon To"), NULL, NULL);
+            wfree(entry->text);
+            entry->text = _("Move Icon To"); /* can be: Move Icons to */
+            scr->clip_submenu = makeWorkspaceMenu(scr);
+            if (scr->clip_submenu)
+                wMenuEntrySetCascade(menu, entry, scr->clip_submenu);
+        }
 
         entry = wMenuAddCallback(menu, _("Remove Icon"), removeIconsCallback,
                                  NULL);
         wfree(entry->text);
-        entry->text = _("Remove Icon");
+        entry->text = _("Remove Icon"); /* can be: Remove Icons */
 
         wMenuAddCallback(menu, _("Attract Icons"), colectIconsCallback, NULL);
     }
@@ -1169,21 +1265,26 @@
 
     entry = wMenuAddCallback(menu, _("Hide"), hideCallback, NULL);
     wfree(entry->text);
-    entry->text = _("Hide");
+    entry->text = _("Hide"); /* can be: Unhide */
 
     wMenuAddCallback(menu, _("Settings..."), settingsCallback, NULL);
 
-    wMenuAddCallback(menu, _("Kill"), killCallback, NULL);
+    entry = wMenuAddCallback(menu, _("Kill"), killCallback, NULL);
+    wfree(entry->text);
+    entry->text = _("Kill"); /* can be: Remove drawer */
 
     if (type == WM_CLIP)
         scr->clip_menu = menu;
 
+    if (type == WM_DRAWER)
+        scr->drawer_menu = menu;
+
     return menu;
 }
 
 
 WDock*
-wDockCreate(WScreen *scr, int type)
+wDockCreate(WScreen *scr, int type, char *name)
 {
     WDock *dock;
     WAppIcon *btn;
@@ -1194,17 +1295,24 @@
     dock = wmalloc(sizeof(WDock));
     memset(dock, 0, sizeof(WDock));
 
-    if (type == WM_CLIP)
+    switch (type) {
+    case WM_CLIP:
         icon_count = CLIP_MAX_ICONS;
-    else
+        break;
+    case WM_DOCK:
+    default:
         icon_count = scr->scr_height/wPreferences.icon_size;
+        break;
+    case WM_DRAWER:
+        icon_count = scr->scr_width/wPreferences.icon_size;
+    }
 
     dock->icon_array = wmalloc(sizeof(WAppIcon*)*icon_count);
     memset(dock->icon_array, 0, sizeof(WAppIcon*)*icon_count);
 
     dock->max_icons = icon_count;
 
-    btn = mainIconCreate(scr, type);
+    btn = mainIconCreate(scr, type, name);
 
     btn->dock = dock;
 
@@ -1213,22 +1321,35 @@
     dock->screen_ptr = scr;
     dock->type = type;
     dock->icon_count = 1;
-    dock->on_right_side = 1;
+    if (type == WM_DRAWER)
+        dock->on_right_side = scr->dock->on_right_side;
+    else
+        dock->on_right_side = 1;
     dock->collapsed = 0;
     dock->auto_collapse = 0;
     dock->auto_collapse_magic = NULL;
-    dock->auto_raise_lower = 0;
+    dock->auto_raise_lower = (type == WM_DRAWER ? 1 : 0);
     dock->auto_lower_magic = NULL;
     dock->auto_raise_magic = NULL;
     dock->attract_icons = 0;
     dock->lowered = 1;
     dock->icon_array[0] = btn;
+    if (type == WM_DRAWER) {
+        if (scr->dock->lowered) /* Because drawer is lowered, its main
+                                 * tile is at the same level as the dock. */
+            ChangeStackingLevel(btn->icon->core, WMNormalLevel);
+        else
+            ChangeStackingLevel(btn->icon->core, WMDockLevel);
+    }
     wRaiseFrame(btn->icon->core);
     XMoveWindow(dpy, btn->icon->core->window, btn->x_pos, btn->y_pos);
 
     /* create dock menu */
     dock->menu = dockMenuCreate(scr, type);
 
+    if (type == WM_DRAWER)
+        drawerAppendToChain(scr, dock);
+
     return dock;
 }
 
@@ -1327,6 +1448,8 @@
 {
     if (btn == btn->icon->core->screen_ptr->clip_icon)
         wClipIconPaint(btn);
+    else if (isADrawer(btn->icon->core->screen_ptr, btn))
+        wDrawerIconPaint(btn);
     else
         wAppIconPaint(btn);
 }
@@ -1453,7 +1576,7 @@
     value = (dock->lowered ? dYes : dNo);
     WMPutInPLDictionary(dock_state, dLowered, value);
 
-    if (dock->type == WM_CLIP) {
+    if (dock->type == WM_CLIP || dock->type == WM_DRAWER) {
         value = (dock->collapsed ? dYes : dNo);
         WMPutInPLDictionary(dock_state, dCollapsed, value);
 
@@ -1599,7 +1722,7 @@
     }
 
     aicon->icon->core->descriptor.handle_mousedown = iconMouseDown;
-    if (type == WM_CLIP) {
+    if (type == WM_CLIP || type == WM_DRAWER) {
         aicon->icon->core->descriptor.handle_enternotify = clipEnterNotify;
         aicon->icon->core->descriptor.handle_leavenotify = clipLeaveNotify;
     }
@@ -1680,7 +1803,7 @@
     WMPropList *value;
 
 
-    icon = mainIconCreate(scr, WM_CLIP);
+    icon = mainIconCreate(scr, WM_CLIP, NULL);
 
     if (!clip_state)
         return icon;
@@ -1740,7 +1863,7 @@
     int count, i;
 
 
-    dock = wDockCreate(scr, type);
+    dock = wDockCreate(scr, type, NULL);
 
     if (!dock_state)
         return dock;
@@ -2190,7 +2313,7 @@
     icon->docked = 1;
     icon->dock = dock;
     icon->icon->core->descriptor.handle_mousedown = iconMouseDown;
-    if (dock->type == WM_CLIP) {
+    if (dock->type == WM_CLIP || dock->type == WM_DRAWER) {
         icon->icon->core->descriptor.handle_enternotify = clipEnterNotify;
         icon->icon->core->descriptor.handle_leavenotify = clipLeaveNotify;
     }
@@ -2224,7 +2347,7 @@
 
 
 void
-reattachIcon(WDock *dock, WAppIcon *icon, int x, int y)
+wDockReattachIcon(WDock *dock, WAppIcon *icon, int x, int y)
 {
     int index;
 
@@ -2243,7 +2366,7 @@
 
 
 Bool
-moveIconBetweenDocks(WDock *src, WDock *dest, WAppIcon *icon, int x, int y)
+wDockMoveIconBetweenDocks(WDock *src, WDock *dest, WAppIcon *icon, int x, int y)
 {
     WWindow *wwin;
     char *command;
@@ -2289,7 +2412,7 @@
         }
     }
 
-    if (dest->type == WM_DOCK)
+    if (dest->type == WM_DOCK || dest->type == WM_DRAWER)
         wClipMakeIconOmnipresent(icon, False);
 
     for(index=1; index<src->max_icons; index++) {
@@ -2328,7 +2451,7 @@
     /* set it to be kept when moving to dock.
      * Unless the icon does not have a command set
      */
-    if (icon->command && dest->type==WM_DOCK) {
+    if (icon->command && (dest->type == WM_DOCK || dest->type == WM_DRAWER)) {
         icon->attracted = 0;
         if (icon->icon->shadowed) {
             icon->icon->shadowed = 0;
@@ -2441,6 +2564,8 @@
  * Note: this function should NEVER alter ret_x or ret_y, unless it will
  * return True. -Dan
  */
+/* Redocking == true means either icon->dock == dock (normal case)
+ *                         or we are called from handleDockMove for a drawer */
 Bool
 wDockSnapIcon(WDock *dock, WAppIcon *icon, int req_x, int req_y,
               int *ret_x, int *ret_y, int redocking)
@@ -2494,8 +2619,22 @@
             return False;
     }
 
-    if (dock->type == WM_DOCK) {
-        if (icon->dock != dock && ex_x != 0)
+    switch (dock->type) {
+    case WM_DOCK:
+    {
+        /* We can return False right away if
+         * - we do not come from this dock (which is a WM_DOCK),
+         * - we are not right over it, and
+         * - we are not the main tile of a drawer.
+         * In the latter case, we are called from handleDockMove. */
+	if (icon->dock != dock && ex_x != 0 &&
+            !(icon->dock && icon->dock->type == WM_DRAWER && icon == icon->dock->icon_array[0]))
+	    return False;
+
+	if (!redocking && ex_x != 0)
+            return False;
+
+        if (getDrawer(scr, ex_y)) /* Return false so that the drawer gets it. */
             return False;
 
         aicon = NULL;
@@ -2513,6 +2652,7 @@
             /* Possible cases when redocking:
              *
              * icon dragged out of range of any slot -> false
+             * icon dragged on a drawer -> false (to open the drawer)
              * icon dragged to range of free slot
              * icon dragged to range of same slot
              * icon dragged to range of different icon
@@ -2551,6 +2691,8 @@
                             break;
                         }
                     }
+                    /* slot is used by a drawer */
+                    done = done && !getDrawer(scr, closest);
                 }
                 sig = -sig;
             }
@@ -2571,7 +2713,10 @@
                 return True;
             }
         }
-    } else { /* CLIP */
+        break;
+    }
+    case WM_CLIP:
+    {
         int neighbours = 0;
         int start, stop, k;
 
@@ -2615,6 +2760,50 @@
             *ret_y = ex_y;
             return True;
         }
+        break;
+    }
+    case WM_DRAWER:
+    {
+        WAppIcon *aicons_to_shift[ dock->icon_count ];
+        int index_of_hole, j;
+
+        if (ex_y != 0 ||
+            abs(ex_x) - dock->icon_count > DOCK_DETTACH_THRESHOLD ||
+            (ex_x < 0 && !dock->on_right_side) ||
+            (ex_x > 0 &&  dock->on_right_side)) {
+            return False;
+        }
+
+        if (ex_x == 0)
+            ex_x = (dock->on_right_side ? -1 : 1);
+
+        /* "Reduce" ex_x but keep its sign */
+        if (redocking) {
+            if (abs(ex_x) > dock->icon_count - 1) /* minus 1: do not take icon_array[0] into account */
+                ex_x = ex_x * (dock->icon_count - 1) / abs(ex_x); /* don't use *= ! */
+        } else {
+            if (abs(ex_x) > dock->icon_count)
+                ex_x = ex_x * dock->icon_count / abs(ex_x);
+        }
+        index_of_hole = indexOfHole(dock, icon, redocking);
+
+        /* Find the appicons between where icon was (index_of_hole) and where
+         * it wants to be (ex_x) and slide them. */
+        j = 0;
+        for (i = 1; i < dock->max_icons; i++) {
+            if ((aicon = dock->icon_array[ i ]) && aicon != icon &&
+                ((ex_x <= aicon->xindex && aicon->xindex < index_of_hole) ||
+                 (index_of_hole < aicon->xindex && aicon->xindex <= ex_x)))
+                aicons_to_shift[ j++ ] = aicon;
+        }
+        assert(j == abs(ex_x - index_of_hole));
+
+        wSlideAppicons(aicons_to_shift, j, (index_of_hole < ex_x));
+
+        *ret_x = ex_x;
+        *ret_y = ex_y;
+        return True;
+    }
     }
     return False;
 }
@@ -2652,6 +2841,15 @@
     int sx=0, sy=0, ex=scr->scr_width, ey=scr->scr_height;
     int extra_count=0;
 
+    if (dock->type == WM_DRAWER) {
+        if (dock->icon_count >= dock->max_icons) { /* drawer is full */
+            return False;
+        }
+        *x_pos = dock->icon_count * (dock->on_right_side ? -1 : 1);
+        *y_pos = 0;
+        return True;
+    }
+
     if (dock->type == WM_CLIP &&
         dock != scr->workspaces[scr->current_workspace]->clip)
         extra_count = scr->global_icon_count;
@@ -2913,8 +3111,13 @@
 moveDock(WDock *dock, int new_x, int new_y)
 {
     WAppIcon *btn;
+    WDrawerChain *dc;
     int i;
 
+    if (dock->type == WM_DOCK) {
+        for (dc = dock->screen_ptr->drawers; dc != NULL; dc = dc->next)
+            moveDock(dc->adrawer, new_x, dc->adrawer->y_pos - dock->y_pos + new_y);
+    }
     dock->x_pos = new_x;
     dock->y_pos = new_y;
     for (i=0; i<dock->max_icons; i++) {
@@ -2942,6 +3145,8 @@
         x = dock->x_pos = DOCK_EXTRA_SPACE;
     }
 
+    swapDrawers(scr, dock->on_right_side, x);
+
     for (i=0; i<dock->max_icons; i++) {
         btn = dock->icon_array[i];
         if (btn) {
@@ -3012,7 +3217,8 @@
             state->hidden = -1;
             state->miniaturized = -1;
             state->shaded = -1;
-            if (btn->dock==scr->dock || btn->omnipresent)
+            if (btn->dock == scr->dock ||
+                btn->dock->type == WM_DRAWER || btn->omnipresent)
                 state->workspace = -1;
             else
                 state->workspace = scr->current_workspace;
@@ -3059,17 +3265,6 @@
     btn = dock->icon_array[0];
     moveDock(dock, btn->x_pos, btn->y_pos);
 
-    newlevel = dock->lowered ? WMNormalLevel : WMDockLevel;
-    ChangeStackingLevel(btn->icon->core, newlevel);
-
-    for (i=1; i<dock->max_icons; i++) {
-        if (dock->icon_array[i]) {
-            MoveInStackListAbove(dock->icon_array[i]->icon->core,
-                                 btn->icon->core);
-            break;
-        }
-    }
-
     if (!dock->collapsed) {
         for (i=1; i<dock->max_icons; i++) {
             if (dock->icon_array[i]) {
@@ -3087,7 +3282,12 @@
 wDockLower(WDock *dock)
 {
     int i;
+    WDrawerChain *dc;
 
+    if (dock->type == WM_DOCK) {
+        for (dc = dock->screen_ptr->drawers; dc != NULL; dc = dc->next)
+            wDockLower(dc->adrawer);
+    }
     for (i=0; i<dock->max_icons; i++) {
         if (dock->icon_array[i])
             wLowerFrame(dock->icon_array[i]->icon->core);
@@ -3099,11 +3299,16 @@
 wDockRaise(WDock *dock)
 {
     int i;
+    WDrawerChain *dc;
 
     for (i=dock->max_icons-1; i>=0; i--) {
         if (dock->icon_array[i])
             wRaiseFrame(dock->icon_array[i]->icon->core);
     }
+    if (dock->type == WM_DOCK) {
+        for (dc = dock->screen_ptr->drawers; dc != NULL; dc = dc->next)
+            wDockRaise(dc->adrawer);
+    }
 }
 
 
@@ -3262,10 +3467,10 @@
             WAppIconChain *chain = scr->global_icons;
 
             while (chain) {
-                moveIconBetweenDocks(chain->aicon->dock,
-                                     scr->workspaces[workspace]->clip,
-                                     chain->aicon, chain->aicon->xindex,
-                                     chain->aicon->yindex);
+                wDockMoveIconBetweenDocks(chain->aicon->dock,
+                                          scr->workspaces[workspace]->clip,
+                                          chain->aicon, chain->aicon->xindex,
+                                          chain->aicon->yindex);
                 if (scr->workspaces[workspace]->clip->collapsed)
                     XUnmapWindow(dpy, chain->aicon->icon->core->window);
                 chain = chain->next;
@@ -3343,6 +3548,7 @@
 toggleLowered(WDock *dock)
 {
     WAppIcon *tmp;
+    WDrawerChain *dc;
     int newlevel, i;
 
     /* lower/raise Dock */
@@ -3359,13 +3565,29 @@
         if (!tmp)
             continue;
 
-        ChangeStackingLevel(tmp->icon->core, newlevel);
+        /* The only case we do not want to change the stacking level
+         * is for the main tile of a drawer, that is lowered but in a
+         * "kept-on-top" dock */
+        if (!(i == 0 && dock->type == WM_DRAWER &&
+              dock->lowered && !dock->screen_ptr->dock->lowered))
+            ChangeStackingLevel(tmp->icon->core, newlevel);
+
         if (dock->lowered)
             wLowerFrame(tmp->icon->core);
     }
 
-    if (dock->type == WM_DOCK)
+    if (dock->type == WM_DOCK) {
+        for (dc = dock->screen_ptr->drawers; dc != NULL; dc = dc->next) {
+            if (dc->adrawer->lowered) {
+                ChangeStackingLevel(dc->adrawer->icon_array[ 0 ]->icon->core, newlevel);
+                if (dock->lowered)
+                    wDockLower(dc->adrawer);
+                else
+                    wDockRaise(dc->adrawer);
+            }
+        }
         wScreenUpdateUsableArea(dock->screen_ptr);
+    }
 }
 
 
@@ -3400,32 +3622,38 @@
         entry = dock->menu->entries[index];
         entry->flags.indicator_on = !dock->lowered;
         entry->clientdata = dock;
+        /* add a drawer */
+        entry = dock->menu->entries[++index];
+        entry->clientdata = aicon;
+        wMenuSetEnabled(dock->menu, index, True);
         dock->menu->flags.realized = 0;
     } else {
-        /* clip options */
+        /* clip/drawer options */
         if (scr->clip_options)
             updateClipOptionsMenu(scr->clip_options, dock);
 
         n_selected = numberOfSelectedIcons(dock);
 
-        /* Rename Workspace */
-        entry = dock->menu->entries[++index];
-        if (aicon == scr->clip_icon) {
-            entry->callback = renameCallback;
-            entry->clientdata = dock;
-            entry->flags.indicator = 0;
-            entry->text = _("Rename Workspace");
-        } else {
-            entry->callback = omnipresentCallback;
-            entry->clientdata = aicon;
-            if (n_selected > 0) {
+        if (dock->type == WM_CLIP) {
+            /* Rename Workspace */
+            entry = dock->menu->entries[++index];
+            if (aicon == scr->clip_icon) {
+                entry->callback = renameCallback;
+                entry->clientdata = dock;
                 entry->flags.indicator = 0;
-                entry->text = _("Toggle Omnipresent");
+                entry->text = _("Rename Workspace");
             } else {
-                entry->flags.indicator = 1;
-                entry->flags.indicator_on = aicon->omnipresent;
-                entry->flags.indicator_type = MI_CHECK;
-                entry->text = _("Omnipresent");
+                entry->callback = omnipresentCallback;
+                entry->clientdata = aicon;
+                if (n_selected > 0) {
+                    entry->flags.indicator = 0;
+                    entry->text = _("Toggle Omnipresent");
+                } else {
+                    entry->flags.indicator = 1;
+                    entry->flags.indicator_on = aicon->omnipresent;
+                    entry->flags.indicator_type = MI_CHECK;
+                    entry->text = _("Omnipresent");
+                }
             }
         }
 
@@ -3433,7 +3661,8 @@
         entry = dock->menu->entries[++index];
         entry->clientdata = aicon;
         entry->flags.indicator_on = aicon->icon->selected;
-        wMenuSetEnabled(dock->menu, index, aicon!=scr->clip_icon);
+        wMenuSetEnabled(dock->menu, index,
+                        aicon!=scr->clip_icon && !isADrawer(scr, aicon));
 
         /* select/unselect all icons */
         entry = dock->menu->entries[++index];
@@ -3453,15 +3682,17 @@
             entry->text = _("Keep Icon");
         wMenuSetEnabled(dock->menu, index, dock->icon_count > 1);
 
-        /* this is the workspace submenu part */
-        entry = dock->menu->entries[++index];
-        if (n_selected > 1)
-            entry->text = _("Move Icons To");
-        else
-            entry->text = _("Move Icon To");
-        if (scr->clip_submenu)
-            updateWorkspaceMenu(scr->clip_submenu, aicon);
-        wMenuSetEnabled(dock->menu, index, !aicon->omnipresent);
+        if (dock->type == WM_CLIP) {
+            /* this is the workspace submenu part */
+            entry = dock->menu->entries[++index];
+            if (n_selected > 1)
+                entry->text = _("Move Icons To");
+            else
+                entry->text = _("Move Icon To");
+            if (scr->clip_submenu)
+                updateWorkspaceMenu(scr->clip_submenu, aicon);
+            wMenuSetEnabled(dock->menu, index, !aicon->omnipresent);
+        }
 
         /* remove icon(s) */
         entry = dock->menu->entries[++index];
@@ -3518,15 +3749,23 @@
     wMenuSetEnabled(dock->menu, index, !aicon->editing
                     && !wPreferences.flags.noupdates);
 
-    /* kill */
+    /* kill or remove drawer */
     entry = dock->menu->entries[++index];
     entry->clientdata = aicon;
-    wMenuSetEnabled(dock->menu, index, appIsRunning);
+    if (isADrawer(scr, aicon)) {
+        entry->callback = removeDrawerCallback;
+        entry->text = _("Remove drawer");
+        wMenuSetEnabled(dock->menu, index, True);
+    } else {
+        entry->callback = killCallback;
+        entry->text = _("Kill");
+        wMenuSetEnabled(dock->menu, index, appIsRunning);
+    }
 
     if (!dock->menu->flags.realized)
         wMenuRealize(dock->menu);
 
-    if (dock->type == WM_CLIP) {
+    if (dock->type == WM_CLIP || dock->type == WM_DRAWER) {
         /*x_pos = event->xbutton.x_root+2;*/
         x_pos = event->xbutton.x_root - dock->menu->frame->core->width/2 - 1;
         if (x_pos < 0) {
@@ -3586,6 +3825,8 @@
                     toggleCollapsed(dock);
                 else
                     handleClipChangeWorkspace(dock->screen_ptr, event);
+	    } else if (isADrawer(dock->screen_ptr, btn)) {
+                toggleCollapsed(dock);
             } else if (btn->command) {
                 if (!btn->launching &&
                     (!btn->running || (event->xbutton.state & ControlMask))) {
